<template>
  <div class="login">
    <AuthForm v-show="!hasTwoFA">
      <form @submit.prevent="onSubmit">
        <div class="form-group">
          <BaseInput v-model="form.login" :is-valid="!!form.login" />
        </div>
        <div class="form-group">
          <BaseInput v-model="form.password" type="password" :is-valid="!!form.password" />
        </div>
        <div class="form-group">
          <BaseButton :is-loading="form.isLoading">Login</BaseButton>
        </div>
      </form>
    </AuthForm>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import AuthForm from '../components/auth/AuthForm'
import BaseInput from '../components/base/BaseInput'
import BaseButton from '../components/base/BaseButton'
import { TYPES } from '../store'

export default {
  components: { AuthForm, BaseInput, BaseButton },
  data () {
    return {
      form: {
        login: '',
        password: '',
        isLoading: false
      },
      hasTwoFA: false
    }
  },
  methods: {
    ...mapActions([TYPES.login]),
    async onSubmit () {
      try {
        const request = this.$2fa.request(async (code) => {
          this.hasTwoFA = !!code
          this.form.isLoading = true
          await this[TYPES.login]({
            data: {
              login: this.form.login,
              password: this.form.password,
              code
            }
          })
        })
        await request()
        this.$router.replace('/')
      } catch (e) {
        console.warn(e)
      } finally {
        this.form.isLoading = false
      }
    }
  }
}
</script>

<style scoped>
.login {
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  background: #eee;
}
.form-group:not(:last-child) {
  margin-bottom: 10px;
}
</style>